use common jenkins pipelines
[osm/SO.git] / BUILD.sh
1 #!/usr/bin/env bash
2 #
3 # Copyright 2016 RIFT.IO Inc
4 #
5 # Licensed under the Apache License, Version 2.0 (the "License");
6 # you may not use this file except in compliance with the License.
7 # You may obtain a copy of the License at
8 #
9 # http://www.apache.org/licenses/LICENSE-2.0
10 #
11 # Unless required by applicable law or agreed to in writing, software
12 # distributed under the License is distributed on an "AS IS" BASIS,
13 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14 # See the License for the specific language governing permissions and
15 # limitations under the License.
16 #
17 # Author(s): Jeremy Mordkoff, Lezz Giles
18 # Creation Date: 08/29/2016
19 #
20 #
21
22 # BUILD.sh
23 #
24 # This is a top-level build script for RIFT.io
25 #
26 # Arguments and options: use -h or --help
27 #
28 # dependencies -- requires sudo rights
29
30 # Defensive bash programming flags
31 set -o errexit # Exit on any error
32 trap 'echo ERROR: Command failed: \"$BASH_COMMAND\"' ERR
33 set -o nounset # Expanding an unset variable is an error. Variables must be
34 # set before they can be used.
35
36 ###############################################################################
37 # Options and arguments
38
39 # There
40 params="$(getopt -o suhb: -l install-so,install-ui,no-mkcontainer,build-ui:,help --name "$0" -- "$@")"
41 if [ $? != 0 ] ; then echo "Failed parsing options." >&2 ; exit 1 ; fi
42
43 eval set -- $params
44
45 installSO=false
46 installUI=false
47 runMkcontainer=true
48 UIPathToBuild=
49
50 while true; do
51 case "$1" in
52 -s|--install-so) installSO=true; shift;;
53 -u|--install-ui) installUI=true; shift;;
54 -b|--build-ui) shift; UIPathToBuild=$1; shift;;
55 --no-mkcontainer) runMkcontainer=false; shift;;
56 -h|--help)
57 echo
58 echo "NAME:"
59 echo " $0"
60 echo
61 echo "SYNOPSIS:"
62 echo " $0 -h|--help"
63 echo " $0 [-s] [-u|-b PATH-TO-UI-REPO] [PLATFORM_REPOSITORY] [PLATFORM_VERSION]"
64 echo
65 echo "DESCRIPTION:"
66 echo " Prepare current system to run SO and UI. By default, the system"
67 echo " is set up to support building SO and UI; optionally, either or"
68 echo " both SO and UI can be installed from a Debian package repository."
69 echo
70 echo " -s|--install-so: install SO from package"
71 echo " -u|--install-ui: install UI from package"
72 echo " -b|--build-ui PATH-TO-UI-REPO: build the UI in the specified repo"
73 echo " --no-mkcontainer: do not run mkcontainer, used for debugging script"
74 echo " PLATFORM_REPOSITORY (optional): name of the RIFT.ware repository."
75 echo " PLATFORM_VERSION (optional): version of the platform packages to be installed."
76 echo
77 exit 0;;
78 --) shift; break;;
79 *) echo "Not implemented: $1" >&2; exit 1;;
80 esac
81 done
82
83 if $installUI && [[ $UIPathToBuild ]]; then
84 echo "Cannot both install and build the UI!"
85 exit 1
86 fi
87
88 if [[ $UIPathToBuild && ! -d $UIPathToBuild ]]; then
89 echo "Not a directory: $UIPathToBuild"
90 exit 1
91 fi
92
93 # Turn this on after handling options, so the output doesn't get cluttered.
94 set -x # Print commands before executing them
95
96 ###############################################################################
97 # Find the platform
98 PYTHON=python
99 if [[ ! -f /usr/bin/python ]]; then
100 PYTHON=python3
101 fi
102
103 if $PYTHON -mplatform | grep -qi fedora; then
104 PLATFORM=fc20
105 elif $PYTHON -mplatform | grep -qi ubuntu; then
106 PLATFORM=ub16
107 else
108 echo "Unknown platform"
109 exit 1
110 fi
111
112 ###############################################################################
113 # Set up repo and version
114
115 if [[ $PLATFORM == ub16 ]]; then
116 PLATFORM_REPOSITORY=${1:-OSM}
117 PLATFORM_VERSION=${2:-4.4.0.0.57702}
118 elif [[ $PLATFORM == fc20 ]]; then
119 PLATFORM_REPOSITORY=${1:-OSM} # change to OSM when published
120 PLATFORM_VERSION=${2:-4.3.1.0.53705}
121 else
122 echo "Internal error: unknown platform $PLATFORM"
123 exit 1
124 fi
125
126 ###############################################################################
127 # Main block
128
129 # Disable apt-daily.service and apt-daily.timer
130
131 DAILY_TIMER='apt-daily.timer'
132 DAILY_SERVICE='apt-daily.service'
133 if [ $(systemctl is-active $DAILY_TIMER) = "active" ]
134 then
135 systemctl stop $DAILY_TIMER
136 systemctl disable $DAILY_TIMER
137 systemctl disable $DAILY_SERVICE
138 fi
139
140 # must be run from the top of a workspace
141 cd $(dirname $0)
142
143 # inside RIFT.io this is an NFS mount
144 # so just to be safe
145 test -h /usr/rift && sudo rm -f /usr/rift
146
147 if [[ $PLATFORM == ub16 ]]; then
148 # enable the right repos
149 curl http://repos.riftio.com/public/xenial-riftware-public-key | sudo apt-key add -
150 # the old mkcontainer always enabled release which can be bad
151 # so remove it
152 sudo rm -f /etc/apt/sources.list.d/release.list /etc/apt/sources.list.d/rbac.list /etc/apt/sources.list.d/OSM.list
153 # always use the same file name so that updates will overwrite rather than enable a second repo
154 sudo curl -o /etc/apt/sources.list.d/RIFT.list http://buildtracker.riftio.com/repo_file/ub16/${PLATFORM_REPOSITORY}/
155 sudo apt-get update
156
157 # and install the tools
158 sudo apt remove -y rw.toolchain-rwbase tcpdump
159 sudo apt-get install -y --allow-downgrades rw.tools-container-tools=${PLATFORM_VERSION} rw.tools-scripts=${PLATFORM_VERSION} python
160 elif [[ $PLATFORM == fc20 ]]; then
161 # get the container tools from the correct repository
162 sudo rm -f /etc/yum.repos.d/private.repo
163 sudo curl -o /etc/yum.repos.d/${PLATFORM_REPOSITORY}.repo \
164 http://buildtracker.riftio.com/repo_file/fc20/${PLATFORM_REPOSITORY}/
165 sudo yum install --assumeyes rw.tools-container-tools rw.tools-scripts
166 else
167 echo "Internal error: unknown platform $PLATFORM"
168 exit 1
169 fi
170
171 # enable the OSM repository hosted by RIFT.io
172 # this contains the RIFT platform code and tools
173 # and install of the packages required to build and run
174 # this module
175 if $runMkcontainer; then
176 sudo apt-get install -y libxml2-dev libxslt-dev
177 sudo /usr/rift/container_tools/mkcontainer --modes build --modes ext --repo ${PLATFORM_REPOSITORY}
178 sudo pip3 install lxml==3.4.0
179 fi
180
181
182 if [[ $PLATFORM == ub16 ]]; then
183 # install the RIFT platform code:
184 # remove these packages since some files moved from one to the other, and one was obsoleted
185 # ignore failures
186
187 PACKAGES="rw.toolchain-rwbase rw.toolchain-rwtoolchain rw.core.mgmt-mgmt rw.core.util-util \
188 rw.core.rwvx-rwvx rw.core.rwvx-rwdts rw.automation.core-RWAUTO"
189 # this package is obsolete.
190 OLD_PACKAGES="rw.core.rwvx-rwha-1.0"
191 for package in $PACKAGES $OLD_PACKAGES; do
192 sudo apt remove -y $package || true
193 done
194
195 packages=""
196 for package in $PACKAGES; do
197 packages="$packages $package=${PLATFORM_VERSION}"
198 done
199 sudo apt-get install -y --allow-downgrades $packages
200
201 sudo apt-get install python-cinderclient
202
203 sudo chmod 777 /usr/rift /usr/rift/usr/share
204
205 if $installSO; then
206 sudo apt-get install -y \
207 rw.core.mano-rwcal_yang_ylib-1.0 \
208 rw.core.mano-rwconfig_agent_yang_ylib-1.0 \
209 rw.core.mano-rwlaunchpad_yang_ylib-1.0 \
210 rw.core.mano-mano_yang_ylib-1.0 \
211 rw.core.mano-common-1.0 \
212 rw.core.mano-rwsdn_yang_ylib-1.0 \
213 rw.core.mano-rwsdnal_yang_ylib-1.0 \
214 rw.core.mano-rwsdn-1.0 \
215 rw.core.mano-mano-types_yang_ylib-1.0 \
216 rw.core.mano-rwcal-cloudsim-1.0 \
217 rw.core.mano-rwcal-1.0 \
218 rw.core.mano-rw_conman_yang_ylib-1.0 \
219 rw.core.mano-rwcalproxytasklet-1.0 \
220 rw.core.mano-rwlaunchpad-1.0 \
221 rw.core.mano-rwcal-openmano-vimconnector-1.0 \
222 rw.core.mano-rwcal-propcloud1-1.0 \
223 rw.core.mano-lpmocklet_yang_ylib-1.0 \
224 rw.core.mano-rwmon-1.0 \
225 rw.core.mano-rwcloud_yang_ylib-1.0 \
226 rw.core.mano-rwcal-openstack-1.0 \
227 rw.core.mano-rw.core.mano_foss \
228 rw.core.mano-rwmon_yang_ylib-1.0 \
229 rw.core.mano-rwcm-1.0 \
230 rw.core.mano-rwcal-mock-1.0 \
231 rw.core.mano-rwmano_examples-1.0 \
232 rw.core.mano-rwcal-cloudsimproxy-1.0 \
233 rw.core.mano-models-1.0 \
234 rw.core.mano-rwcal-aws-1.0
235 fi
236
237 if $installUI; then
238 sudo apt-get install -y \
239 rw.ui-about \
240 rw.ui-logging \
241 rw.ui-skyquake \
242 rw.ui-accounts \
243 rw.ui-composer \
244 rw.ui-launchpad \
245 rw.ui-debug \
246 rw.ui-config \
247 rw.ui-dummy_component
248 fi
249 elif [[ $PLATFORM == fc20 ]]; then
250
251 temp=$(mktemp -d /tmp/rw.XXX)
252 pushd $temp
253
254 # yum does not accept the --nodeps and --replacefiles options so we
255 # download first and then install
256 yumdownloader rw.toolchain-rwbase-${PLATFORM_VERSION} \
257 rw.toolchain-rwtoolchain-${PLATFORM_VERSION} \
258 rw.core.mgmt-mgmt-${PLATFORM_VERSION} \
259 rw.core.util-util-${PLATFORM_VERSION} \
260 rw.core.rwvx-rwvx-${PLATFORM_VERSION} \
261 rw.core.rwvx-rwha-1.0-${PLATFORM_VERSION} \
262 rw.core.rwvx-rwdts-${PLATFORM_VERSION} \
263 rw.automation.core-RWAUTO-${PLATFORM_VERSION}
264
265 # Install one at a time so that pre-installed packages will not cause a failure
266 for pkg in *rpm; do
267 # Check to see if the package is already installed; do not try to install
268 # it again if it does, since this causes rpm -i to return failure.
269 if rpm -q $(rpm -q -p $pkg) >/dev/null; then
270 echo "WARNING: package already installed: $pkg"
271 else
272 sudo rpm -i --replacefiles --nodeps $pkg
273 fi
274 done
275
276 popd
277 rm -rf $temp
278
279 # this file gets in the way of the one generated by the build
280 sudo rm -f /usr/rift/usr/lib/libmano_yang_gen.so
281
282
283 sudo chmod 777 /usr/rift /usr/rift/usr/share
284
285 if $installSO; then
286 sudo apt-get install -y \
287 rw.core.mc-\*-${PLATFORM_VERSION}
288 fi
289
290 if $installUI; then
291 sudo apt-get install -y \
292 rw.ui-about-${PLATFORM_VERSION} \
293 rw.ui-logging-${PLATFORM_VERSION} \
294 rw.ui-skyquake-${PLATFORM_VERSION} \
295 rw.ui-accounts-${PLATFORM_VERSION} \
296 rw.ui-composer-${PLATFORM_VERSION} \
297 rw.ui-launchpad-${PLATFORM_VERSION} \
298 rw.ui-debug-${PLATFORM_VERSION} \
299 rw.ui-config-${PLATFORM_VERSION} \
300 rw.ui-dummy_component-${PLATFORM_VERSION}
301 fi
302
303 else
304 echo "Internal error: unknown platform $PLATFORM"
305 exit 1
306 fi
307
308 # install some base files used to create VNFs
309 test -d /usr/rift/images || mkdir /usr/rift/images
310 for file in Fedora-x86_64-20-20131211.1-sda-ping.qcow2 Fedora-x86_64-20-20131211.1-sda-pong.qcow2 Fedora-x86_64-20-20131211.1-sda.qcow2; do
311 test -f /usr/rift/images/$file || curl -o /usr/rift/images/$file http://repo.riftio.com/releases/open.riftio.com/4.3.1/$file
312 done
313
314 # If you are re-building SO, you just need to run
315 # these two steps
316 if ! $installSO; then
317 make -j16
318 sudo make install
319 fi
320
321 if [[ $UIPathToBuild ]]; then
322 make -C $UIPathToBuild -j16
323 sudo make -C $UIPathToBuild install
324 fi
325
326 echo "Creating Service ...."
327 sudo $(dirname $0)/create_launchpad_service
328